const IS_DBG				= false;
const LOCATION_DEFAULT		= "Cupertino, CA";
const LOCATION_KEY			= "location";

const POSTER_WIDTH			= 154;
const POSTER_HGHT			= 195;

const FRONT_WIDTH			= 500;
const FRONT_COLLAPSED_HGHT	= 246;
const FRONT_EXPANDED_HGHT	= 418;
const EXPANDED_TOP_HGHT		= 177;

const RESIZE_PHASE1_DUR =
		RESIZE_PHASE2_DUR =
		RESIZE_PHASE3_DUR =
		RESIZE_PHASE4_DUR	= 400;

const SLOW_MO_FACTOR		= 7;
const ANIM_FRAME_RATE		= 13;

var gPosterIndex = 0;
var	gMarqueeIsStopped = true;
var gSortByMovies = true;

var gBrowser;

var gPosterRollRgn;
var gMoviePane;
var gTheaterPane;
var gTrailerPane;
var gBottomPane;

var gCurrMovieInfoScrollbar;
var gCurrTheaterInfoScrollbar;

var gCurrMovieIdx;
var gCurrMovieID;
var gCurrTheaterID;
var gCurrTimeID;
var gCurrPostalCode = null;
var gMoviePosterDefault;

var gColumnLabels = ["Movies", "Theaters", "Showtimes"];

var gIsShowing = true;

//	global Box Office object
var	boxOffice = BoxOffice.instance();

function $(id) {
	return document.getElementById(id);
}

function setInstanceAndGlobalPreferenceForKey(value, key)
{
	setInstancePreferenceForKey(value, key);
	setGlobalPreferenceForKey(value, key)
}

function setInstancePreferenceForKey(value, key)
{
	setGlobalPreferenceForKey(value, Util.createKey(key));
}

function setGlobalPreferenceForKey(value, key)
{
	if (window.widget)
		widget.setPreferenceForKey(value, key);
}

function preferenceForKey(key)
{
	var result;

	if (window.widget)
	{
		result = widget.preferenceForKey(Util.createKey(key));
		
		if (!result)
			result = widget.preferenceForKey(key);
	}
	
	if (!result)
		result = eval(key.toUpperCase() + "_DEFAULT");

	return (result);
}

function loadPreferences()
{
	var location = preferenceForKey(LOCATION_KEY);
	
	Util.$("locationTextField").value = location;
	setInstanceAndGlobalPreferenceForKey(location, LOCATION_KEY);
}

function isValidLocation(n)
{
	if (isFinite(n))
		return (isValidPostalCode(n));

	return (locationValidated);
}

function isValidPostalCode(n)
{
	return (n && isFinite(n) && 5 == n.toString().length && n > 0);
}

function checkLocation()
{	
	var textField = Util.$("locationTextField");
	var location = textField.value;

	if (checkLocation.location != location)
		checkLocation.locationChanged = true;
	else
		checkLocation.locationChanged = false;


	if (isFinite(location) && !isValidPostalCode(location))
	{
		showMenuItem(Util.getLocalizedString("Invalid Zip Code."));
		
		return (false);
	}
	else if (checkLocation.locationChanged && !isValidLocation(location))
		locationChanged();
	else
	{
		setInstanceAndGlobalPreferenceForKey(location, LOCATION_KEY);

		return (true);
	}
	
	return (false);
}

function showMenuItem(text)
{
	if (window.widget)
	{
		var menu = widget.createMenu();
		
		menu.addMenuItem(text);
		menu.setMenuItemEnabledAtIndex(0, false);
		menu.popup(249, 107);
	}
}

function isInCompactView()
{
	var grid = Util.$("grid");
	
	return (grid.className && grid.className.indexOf("collapsed") > -1);
}


function fetchAllData()
{
	if ( !gCurrPostalCode )
	{
		if ( !fetchAllData.fetchingPostalCode )
		{
			// need to get the zip based on the city info
			fetchAllData.fetchingPostalCode = true;
			validateLocation("here", setCurrPostalCode);
			setTimeout( fetchAllData, 100 );
		}
		else
		{
			setTimeout( fetchAllData, 100 );
		}
		return;
	}

	fetchAllData.fetchingPostalCode = false;
	if (!boxOffice.Movie.shouldFetchNewMovieData())
	{
		if (isInCompactView())
		{
			var posterUrl = gMoviePosterDefault;

			if (boxOffice.Movie.getMovieKeys().length)
				gPosterIndex = randomIntegerZeroToNInclusive(boxOffice.Movie.getMovieKeys().length);

			startPosterRollLoop();
		}
		else
			displayAllMovieInfo();
	}
	else
	{
//		_gWaitingForMoviesDataToLoad = false;
		
		boxOffice.Movie.fetchMovieData();
		boxOffice.Theater.fetchTheaterData();
	}
}

function load()
{
	if (window.widget)
	{
		widget.onshow = onshow;
		widget.onhide = onhide;
		widget.onsync = onsync;
		widget.onremove = onremove;
	}
	else
	{
		window.onshow = onshow;
		window.onhide = onhide;
		window.onsync = onsync;
		window.onremove = onremove;
	}

	preLoadImages();
	locateGlobalElements();
	loadPreferences();
	createButtons();
	setUpLocalizedStrings();
	setUpDateSelect();
	
	document.addEventListener("keydown", documentKeyDown, false);
	// onshow is called on launch, but not after cmd-r.
	// therefore, must call fetch method here
	fetchAllData();
}

function preLoadImages()
{
	var img = new Image();
	
	if ( window.devicePixelRatio > 1 )
	{
		$('daisyWheel').src = "img/__movieSpinner@2x.gif";
		$('dateSelectImage').src = "img/popup_ref@2x.png";
		$('dateSelectArrows').src = "img/popuparrows@2x.png";
		$('fandangoLogo').src = "img/fandango@2x.png"
		
		img.src = "img/_video_cntl/pause@2x.png";
		img.src = "img/_video_cntl/play@2x.png";
		img.src = "img/_video_cntl/back@2x.png";
		img.src = "img/_video_cntl/pause_on@2x.png";
		img.src = "img/_video_cntl/play_on@2x.png";
		img.src = "img/_video_cntl/back_on@2x.png";
		img.src = "img/_video_cntl/track@2x.png";
		img.src = "img/_video_cntl/__trackthumb@2x.png";
		img.src = "img/_video_cntl/__scrubthumbInny@2x.png";
		img.src = "img/_video_cntl/__duration@2x.png";
		img.src = "img/selectorshort@2x.png";
		img.src = "img/TrailerExtension@2x.png";
		
		gMoviePosterDefault = "img/filmclip@2x.png";
	}
	else
	{
		img.src = "img/_video_cntl/pause.png";
		img.src = "img/_video_cntl/play.png";
		img.src = "img/_video_cntl/back.png";
		img.src = "img/_video_cntl/pause_on.png";
		img.src = "img/_video_cntl/play_on.png";
		img.src = "img/_video_cntl/back_on.png";
		img.src = "img/_video_cntl/track.png";
		img.src = "img/_video_cntl/__trackthumb.png";
		img.src = "img/_video_cntl/__scrubthumbInny.png";
		img.src = "img/_video_cntl/__duration.png";
		img.src = "img/selectorshort.png";
		img.src = "img/TrailerExtension.png";

		gMoviePosterDefault = "img/filmclip.png";
	}
}

function onshow()
{
	gIsShowing = true;
	if (isInCompactView())
	{
		if (boxOffice.Movie.shouldFetchNewMovieData())
		{
			fetchAllData();
		}
		else
		{
			if (!Util.isShowing(Util.$("errorMsgBox")))
				startPosterRollLoop();
		}
	}
	else
	{
		if (boxOffice.Movie.shouldFetchNewMovieData())
		{
			startProgressAnimation();
			clearFront(fetchAllData);
		}
	}
}

function onhide()
{
	gIsShowing = false;
	
	if (movie && playing)
		playPause();
	
	// this will stop the animation when hidden
	gMarqueeIsStopped = true;
}

function onsync()
{
	loadPreferences();
	boxOffice.markForUpdate();
	onshow();
}

function onremove()
{
	gIsShowing = false;
	setInstancePreferenceForKey(null, LOCATION_KEY);
	gMarqueeIsStopped = true;
}

function locateGlobalElements()
{
	gPosterRollRgn		= Util.$("posterRollRgn");
	gMoviePane			= Util.$("moviePane");
	gTheaterPane		= Util.$("theaterPane");
	gTrailerPane		= Util.$("trailerPane");
	gBottomPane			= Util.$("bottomPane");
}

function createMovieButton(el, text, clickHandler)
{
	return (new AppleButton(el, text, 18,
						   null, null, 0,
						   null, null,
						   null, null, 0,
						   clickHandler));
}

function createButtons()
{
	new AppleInfoButton(Util.$("infoButton"), Util.$("front"), "white", "white", showBack);
	new AppleGlassButton(Util.$("doneButton"), Util.getLocalizedString("Done"), showFront);

	createMovieButton(Util.$("backButton"), "", backButtonClicked);
	createMovieButton(Util.$("playButton"), "", playPause);
}

function setUpLocalizedStrings()
{
	setInnerText("moviesButton", "Movies");
	setInnerText("theatersButton", "Theaters");
	setInnerText("dateSelectText", "Today");
	setInnerText("trailerButton", "View Trailer");
	setInnerText("ticketsButton", "Buy Tickets");
	setInnerText("releaseDateLabel", "Release date:");
	setInnerText("runtimeLabel", "Run time:");
	setInnerText("castLabel", "Cast:");
	setInnerText("directorsLabel", "Directors:");
	setInnerText("genresLabel", "Genre:");
	setInnerText("locationLabel", "City, State or Zip code:");
}

function setInnerText(id, text)
{
	Util.$(id).innerText = Util.getLocalizedString(text);
}

function showBack()
{
	if (gBrowser)
		gBrowser.blur();
	
	if (window.widget)
        widget.prepareForTransition("ToBack");

	Util.hideElement('front');
	Util.showElement('back');
	checkLocation.location = Util.$("locationTextField").value;

	if (window.widget)
		setTimeout("widget.performTransition();", 0);

	setTimeout(selectAllInLocationTextField, 800);
}

function showFront()
{
	dismissValidation();
	Util.$("locationTextField").blur();

	if (!checkLocation())
		return;

	if (window.widget)
        widget.prepareForTransition("ToFront");

	Util.hideElement('back');
	Util.showElement('front');
	
	if (checkLocation.locationChanged)
	{
		clearFront();
		startProgressAnimation();
		boxOffice.markForUpdate();
		setTimeout(fetchAllData, 200);
	}
	
	if (window.widget)
		setTimeout("widget.performTransition();", 200);

	// this should not be necessary, but...
	if (gBrowser)
	{
		setTimeout(selectPreviouslySelectedItem, 500);

		// redraw 1st column
//		gBrowser.render();
		// select previously selected row
//		selectPreviouslySelectedItem();
	}
}

function selectPreviouslySelectedItem()
{
	// find the movie that was selected before we rotated and select it again.
	var row = 0;
	var path;
	
	populateBrowserInfo();
	
	if ( gSortByMovies )
	{
		row = boxOffice.Movie.getMovieKeys().indexOf(gCurrMovieID);
	}
	else
	{
		row = boxOffice.Theater.getTheaterKeys().indexOf(gCurrTheaterID);
	}
	
	path = [row];
	gBrowser.setPath(path);
}

function clearFront(callback, fade)
{
	hideBottomPane(callback, fade);
	
	if (gBrowser)
		gBrowser.clearAllColumns();
}

function startProgressAnimation()
{
	Util.showElement('daisyWheel');
	Util.$('daisyWheel').style.opacity = 1;
}

function stopProgressAnimation()
{
	Util.$('daisyWheel').style.opacity = 0;
	Util.hideElement('daisyWheel');
}

function startPosterRollLoop()
{
	Util.showElement(gPosterRollRgn);

	if (isInCompactView() && gMarqueeIsStopped)
	{
		if ( boxOffice.Movie.getMovieKeys() )
			setTimeout(doCompactMarquee, 0);
		else
			setTimeout(startPosterRollLoop, 2);
	}
	stopProgressAnimation();
}

function posterClicked(evt)
{
	gSortByMovies = true;
	
	Util.removeClassName(Util.$("theatersButton"), "selected");
	Util.addClassName(Util.$("moviesButton"), "selected");

	gCurrMovieID = evt.toElement.alt;				
	
	var isSlowMo = evt && evt.shiftKey;
	var isReverse = false;

	resizePhase1(isSlowMo, isReverse);
	gMarqueeIsStopped = true;
}

//	whatever is returned from this function
//	will be poured into the Poster's content
function createPosterContent()
{	
	var	movieObjs = boxOffice.Movie.getMovieObjs();
	var	movieKeys = boxOffice.Movie.getMovieKeys();

	var idx = gPosterIndex % movieKeys.length;
	var img = document.createElement("img");

	img.className = "moviePoster";
	
	//	store the array index in the Movie Keys
	img.alt = movieObjs[movieKeys[idx]].tms_id;
	img.src = "http://trailers.apple.com" + movieObjs[movieKeys[idx]].poster;

	img.onclick = function () { posterClicked(event); };

	return (img);
}

function doCompactMarquee()
{
	if (gPosterRollRgn.posterRoll == undefined)
	{
	var	movieObjs = boxOffice.Movie.getMovieObjs();
	var	movieKeys = boxOffice.Movie.getMovieKeys();

	//	given the clip region size we need at least
	//	five Posters in the roll to run the animation	
	if (!movieObjs || movieKeys.length < 5) { return; }

	gPosterRollRgn.posterRoll = [];
	
	var	arrayIdx = 0;
	for (var i = 0;i < movieKeys.length;i++)
	{
	//	for (var i = 0;i < 10;i++)
	//	{
		var idx = gPosterIndex % movieKeys.length;

		if (movieObjs[movieKeys[idx]].poster)
		{
			//	create this Poster
			gPosterRollRgn.posterRoll[arrayIdx] = document.createElement("div");

			//	create this Poster's content
			var content = createPosterContent();

			//	add Poster content to Poster
			gPosterRollRgn.posterRoll[arrayIdx].appendChild(content);

			//	place this Poster in this Poster roll
			gPosterRollRgn.posterRoll[arrayIdx].className = "poster";
			gPosterRollRgn.posterRoll[arrayIdx].style.left = (POSTER_WIDTH * arrayIdx) + "px";
			gPosterRollRgn.posterRoll[arrayIdx].style.width = POSTER_WIDTH + "px";
			gPosterRollRgn.posterRoll[arrayIdx].style.height = POSTER_HGHT + "px";

			gPosterRollRgn.appendChild(gPosterRollRgn.posterRoll[arrayIdx++]);
		}
		
		++gPosterIndex;
	}
	}
	gMarqueeIsStopped = false;

	shiftPosterRollLeft();
}

function shiftPosterRollLeft()
{
	//	the idea here is to use a purpose built function
	//	which is as specific as possible to the task at hand

	//	get the Poster roll
	var posterRoll = gPosterRollRgn.posterRoll;

	//	shift every Poster in the roll left by one pixel
	for (var i = 0;i < posterRoll.length;i++)
		posterRoll[i].style.left = (parseInt(posterRoll[i].style.left) - 1) + 'px';
	
	//	get the left most Poster
	var leftPoster = posterRoll[0];

	var	left = parseInt(leftPoster.style.left);
	var	width = parseInt(leftPoster.style.width);
	
	//	if left Poster has rolled off the left side of the marquee
	if (left + width < 0)
	{
		//	shift it out of the left side of the array
		posterRoll.shift();

		leftPoster.style.left = (left + width * posterRoll.length) + 'px';
		
		// push it back in the right side
		posterRoll.push(leftPoster);
	}

	if ( gIsShowing && isInCompactView())
		gPosterRollRgn.timeout = setTimeout('shiftPosterRollLeft()', 29);
}

function fadeHandler(el, current) { el.style.opacity = current; }

// this phase fades out the posters and gloss
function resizePhase1(isSlowMo, isReverse)
{
	var duration = isSlowMo ? RESIZE_PHASE1_DUR * SLOW_MO_FACTOR : RESIZE_PHASE1_DUR;
	var animator = new AppleAnimator(duration, ANIM_FRAME_RATE);
	var startVal = (isReverse) ? 0 : 1;
	var endVal = (isReverse) ? 1 : 0;
    
	animator.addAnimation(new AppleAnimation(startVal, endVal, function(an, curr, start, end) {fadeHandler(gPosterRollRgn, curr)} ));
	
	function cb(isSlowMo, isReverse)
	{
		//	alert("cb1");
		gPosterRollRgn.style.opacity = (isReverse) ? 1 : 0;

		if (isReverse)
		{
			if (showingErrorMsgBox)
				Util.hideElement(gPosterRollRgn);
			else
				startPosterRollLoop();
		}
		else
		{
            resizePhase2(isSlowMo, false);

			if (window.widget)
				widget.resizeAndMoveTo(window.screenX, window.screenY, FRONT_WIDTH, FRONT_EXPANDED_HGHT);
		}
	}

	animator.oncomplete = function() { cb(isSlowMo, isReverse) };
	animator.start();
}

// this phase actually resizes the widget
function resizePhase2(isSlowMo, isReverse)
{
	var smallRect = new AppleRect(0, 0, FRONT_WIDTH, FRONT_COLLAPSED_HGHT);
	var largeRect = new AppleRect(0, 0, FRONT_WIDTH, FRONT_EXPANDED_HGHT);
	var startRect = (isReverse) ? largeRect : smallRect;
	var endRect   = (isReverse) ? smallRect : largeRect;
	var duration = isSlowMo ? RESIZE_PHASE2_DUR * SLOW_MO_FACTOR : RESIZE_PHASE2_DUR;
	var animator = new AppleAnimator(duration, ANIM_FRAME_RATE);
	
	function animHandler(anime, currRect, startRect, endRect) { Util.$("front").style.height = parseInt(currRect.bottom) + "px"; }

	animator.addAnimation(new AppleRectAnimation(startRect, endRect, animHandler));
	
	function cb(isSlowMo, isReverse)
	{
		//	alert("cb2");
		if (isReverse)
		{
			Util.$("front").style.height = FRONT_COLLAPSED_HGHT + "px";

			if (window.widget)
				widget.resizeAndMoveTo(window.screenX, window.screenY, FRONT_WIDTH, FRONT_COLLAPSED_HGHT);

			resizePhase1(isSlowMo, isReverse);
		}
		else
		{
			Util.$("front").style.height = FRONT_EXPANDED_HGHT + "px";
			
			resizePhase3(isSlowMo, isReverse);
		}
	}

	animator.oncomplete = function() { cb(isSlowMo, isReverse) };
	animator.start();
}

// this phse slides down the gray background
function resizePhase3(isSlowMo, isReverse)
{
	var duration = isSlowMo ? RESIZE_PHASE3_DUR * SLOW_MO_FACTOR : RESIZE_PHASE3_DUR;
	var start = (isReverse) ? EXPANDED_TOP_HGHT : 7;
	var end = (isReverse) ? 7 : EXPANDED_TOP_HGHT;
	var animator = new AppleAnimator(duration, ANIM_FRAME_RATE);
	
	var expandedTop = Util.$("expandedTop");
	
	function animHandler(anime, curr, start, end) { expandedTop.style.height = curr + "px"; }

	animator.addAnimation(new AppleAnimation(start, end, animHandler));
	
	function cb(isSlowMo, isReverse)
	{
		//	alert("cb3");
		if (isReverse)
		{
			Util.hideElement('expandedView');
			resizePhase2(isSlowMo, isReverse);
		}
		else
		{
			expandedTop.style.height = EXPANDED_TOP_HGHT + "px";
			Util.hideElement(gPosterRollRgn);
			resizePhase4(isSlowMo, isReverse);
		}
	}

	animator.oncomplete = function() { cb(isSlowMo, isReverse) };
	animator.start();
	
	Util.showElement('expandedView');
}


// browser fades in
function resizePhase4(isSlowMo, isReverse)
{
	var expandedTop = Util.$("expandedTop");
	var browserContainer = Util.$("browserContainer");
	
	if (isReverse)
	{
		Util.$("grid").className = "collapsed";
		Util.hideElement('infoButton');
	}
	else
	{
		browserContainer.style.opacity = 0;
		expandedTop.style.opacity = 0;
		Util.showElement(browserContainer);
		Util.showElement(expandedTop);
	}

	var duration = isSlowMo ? RESIZE_PHASE4_DUR * SLOW_MO_FACTOR : RESIZE_PHASE4_DUR;
	var animator = new AppleAnimator(duration, ANIM_FRAME_RATE);

	var animHandler = function(an, curr, start, end) {
		fadeHandler(browserContainer, curr);
		fadeHandler(expandedTop, curr);
	};
	
	var start = (isReverse) ? 1 : 0;
	var end = (isReverse) ? 0 : 1;

	animator.addAnimation(new AppleAnimation(start, end, animHandler));
	
	function ch4(isSlowMo, isReverse)
	{
		//	alert("cb4");
		if (isReverse)
		{
			browserContainer.style.opacity = 0;
			expandedTop.style.opacity = 0;
			Util.hideElement(browserContainer);
			Util.hideElement(expandedTop);
			resizePhase3(isSlowMo, isReverse);
		}
		else
		{
			Util.showElement('infoButton');
			browserContainer.style.opacity = 1;
			expandedTop.style.opacity = 1;
			Util.$("grid").className = "expanded";
			startProgressAnimation();
			displayAllMovieInfo();
		}
	}

	animator.oncomplete = function() { ch4(isSlowMo, isReverse) };
	animator.start();

	if (isReverse)
		removeTopbarEventListener();
}

function displayAllMovieInfo()
{
	try
	{
		populateBrowserInfo();
	} catch (e) {
		handleNoDataAvailable();
		return;
	}
	makeBrowserSelections();
	stopProgressAnimation();
}

function setUpDateSelect()
{
	var date = new Date();
	
	// today
	var html = "<option value='" + serializedStringForDate(date) +"'>" + Util.getLocalizedString("Today") + "</option>";
	// tomorrow
	date.setTime( date.getTime() +  86400000 ); // add a day
	html += "<option value='" + serializedStringForDate(date) +"'>" + Util.getLocalizedString("Tomorrow") + "</option>";
	
	// next 5 days
	for (var i = 0; i < 5; i++)
	{
		date.setTime( date.getTime() +  86400000 ); // add a day
		html += "<option value='" + serializedStringForDate(date) +"'>" + displayStringForDate(date) + "</option>";
	}

	var dateSelectEl = Util.$("dateSelect");
	dateSelectEl.innerHTML = html;
	updateDateSelectText();
}

//	Returns date in string format: "yyyy-mm-dd" eg "2006-10-16" for October 16, 2006
function serializedStringForDate(date)
{
	var month = date.getMonth() + 1; // 0-based month, eg 0 == Jan, 11 == Dec so add 1
	var day   = date.getDate(); 	 // 1-based day of month eg 1 thru 31

	month = (month < 10) ? "0" + month : "" + month;	// pad single digits
	day   = (day   < 10) ? "0" + day   : "" + day;		// pad single digits

	var year = date.getFullYear();
	
	return (year + "-" + month + "-" + day);
}

function displayStringForDate(date)
{
	var result = date.toDateString();
	
	return (result.substring(0, result.lastIndexOf(" ")));
}

function dateSelectChanged(evt)
{
	startProgressAnimation();
	updateDateSelectText();
	boxOffice.markForUpdate();
	
	var callback = function () { clearFront(fetchAllData, true); };
	
	if (Util.isShowing(gTrailerPane))
		stopMovie(callback);
	else
		callback();
	
	Util.consumeEvent(evt);
}

function updateDateSelectText()
{
	var selectEl = Util.$("dateSelect");
	var displayStr = selectEl.options[selectEl.selectedIndex].innerHTML;
	Util.$("dateSelectText").innerHTML = displayStr;
}

function hideBottomPane(callback, fade)
{
	var callbackFunc = function ()
	{
		Util.hideElement(gTheaterPane);
		Util.hideElement(gTrailerPane);

		if (!fade)
			bottomPaneFadeOutCompleteHandler(callback);
		else
		{
			var func = function(anime, curr, st, fin) {fadeHandler(gBottomPane, curr)};
			var timer = new AppleAnimator(RESIZE_PHASE4_DUR, ANIM_FRAME_RATE, 1, 0, func);
			timer.oncomplete = function() {bottomPaneFadeOutCompleteHandler(callback)};
			timer.start();
		}
	}
	
	if (Util.isShowing(gTrailerPane))
		stopMovie(callbackFunc);
	else
		callbackFunc();
}

function showBottomPane(fade)
{
	var duration = (fade) ? 200 : 0;
	
	Util.showElement(gBottomPane);
	
	var func = function(anime, curr, st, fin) {fadeHandler(gBottomPane, curr)};
	var timer = new AppleAnimator(duration,	ANIM_FRAME_RATE, 0.0, 1.0, func);
	
	timer.oncomplete = bottomPaneFadeInCompleteHandler;
	timer.start();
}

function bottomPaneFadeOutCompleteHandler(callback)
{
	gBottomPane.style.opacity = 0;

	if (callback)
		callback();
	
	if (gBrowser)
		gBrowser.focus();
}

function bottomPaneFadeInCompleteHandler()
{
	gBottomPane.style.opacity = 1;
}

function setUpCurrentInfoScrollbars()
{
	var currentMovieInfoEl = Util.$("currentMovieInfo");
	var currentTheaterInfoEl = Util.$("currentTheaterInfo");

	if (Util.isShowing(currentMovieInfoEl))
	{
		if (gCurrMovieInfoScrollbar)
		{
			gCurrMovieInfoScrollbar.remove();
			gCurrMovieInfoScrollbar = null;
		}
		
		gCurrMovieInfoScrollbar = new AppleVerticalScrollbar(Util.$("currentMovieInfoScroll"));
		gCurrMovieInfoScrollbar.setSize(7);
		configureScrollbarWithCustomArt(gCurrMovieInfoScrollbar);
		new AppleScrollArea(currentMovieInfoEl, gCurrMovieInfoScrollbar).singleScrollPixels = 5;
	}
	else if (Util.isShowing(currentTheaterInfoEl))
	{
		if (gCurrTheaterInfoScrollbar)
		{
			gCurrTheaterInfoScrollbar.remove();
			gCurrTheaterInfoScrollbar = null;
		}
		
		gCurrTheaterInfoScrollbar = new AppleVerticalScrollbar(Util.$("currentTheaterInfoScroll"));
		gCurrTheaterInfoScrollbar.setSize(7);
		configureScrollbarWithCustomArt(gCurrTheaterInfoScrollbar);
		new AppleScrollArea(currentTheaterInfoEl, gCurrTheaterInfoScrollbar).singleScrollPixels = 5;
	}
}

function configureScrollbarWithCustomArt(scrollbar)
{
	if ( window.devicePixelRatio > 1 )
	{
		scrollbar.setTrackStart("img/_scroll/_track_top@2x.png", 7);
		scrollbar.setThumbStart("img/_scroll/marquee_top@2x.png", 4);
		
		scrollbar.setTrackMiddle("img/_scroll/_track_mid@2x.png", 1);
		scrollbar.setThumbMiddle("img/_scroll/marquee_mid@2x.png", 1);
		
		scrollbar.setTrackEnd("img/_scroll/_track_btm@2x.png", 7);
		scrollbar.setThumbEnd("img/_scroll/marquee_btm@2x.png", 4);
	}
	else
	{
		scrollbar.setTrackStart("img/_scroll/_track_top.png", 7);
		scrollbar.setThumbStart("img/_scroll/marquee_top.png", 4);
		
		scrollbar.setTrackMiddle("img/_scroll/_track_mid.png", 1);
		scrollbar.setThumbMiddle("img/_scroll/marquee_mid.png", 1);
		
		scrollbar.setTrackEnd("img/_scroll/_track_btm.png", 7);
		scrollbar.setThumbEnd("img/_scroll/marquee_btm.png", 4);
	}
}

//---------------------------------------------------------------------------------------
// #mark ========== Populate Info Panels ==========
//---------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------
function populateInfoPaneWithMovieInfo()
{
	var	movies = boxOffice.Movie.getMovieObjs();
	var movieKeys = boxOffice.Movie.getMovieKeys();
	var	currentMovie = movies[gCurrMovieID];

	Util.$("currentTitle").innerHTML 	= spanWithText(currentMovie.title);

	populateSingleMovieInfoItem(currentMovie, "ratingPercent");	
	populateSingleMovieInfoItem(currentMovie, "releaseDate");
	populateSingleMovieInfoItem(currentMovie, "runtime");
	populateSingleMovieInfoItem(currentMovie, "genres");
	populateSingleMovieInfoItem(currentMovie, "cast");
	populateSingleMovieInfoItem(currentMovie, "directors");
	populateSingleMovieInfoItem(currentMovie, "synopsis");
	populateSingleMovieInfoItem(currentMovie, "rating");

	if ( currentMovie.posterUrl )
	{
		Util.$("currentPoster").src = currentMovie.posterUrl;
	}
	else
	{
		Util.$("currentPoster").src = gMoviePosterDefault;
	}
	
	var currentPosterTitleEl = Util.$("currentPosterTitle");
	
	if (currentMovie.trailer && currentMovie.trailer.url != "#")
	{
		Util.$("trailerButton").className = "enabledActionButton";
		Util.$("trailerButton").onclick = trailerButtonClicked;
		
		Util.hideElement(currentPosterTitleEl);
	}
	else
	{
		Util.showElement(currentPosterTitleEl);
		
		currentPosterTitleEl.innerHTML = currentMovie.title;
		
		// center the movie name vertically
		var style = document.defaultView.getComputedStyle(currentPosterTitleEl, "");
		var movieTitleHeight = parseInt(style.getPropertyValue("height"), 10);
		
		movieTitleHeight = (isNaN(movieTitleHeight) ? 0 : movieTitleHeight);
		
		var posY = (POSTER_HGHT - movieTitleHeight) / 2;
		
		currentPosterTitleEl.style.top = posY + "px";
		Util.$("trailerButton").className = "disabledActionButton";
	}
	
	if ( currentMovie.ratingPercent )
	{
		var percent = parseInt(currentMovie.ratingPercent)
		var percentClass = percent > 50 ? "red":"green";
		Util.$("currentRatingPercent").className = percentClass;
	}
	
	Util.$("ticketsButton").onclick = ticketsButtonClicked;

}

//---------------------------------------------------------------------------------------
function populateSingleMovieInfoItem(movie, name)
{
	var value = movie[name];
	
	value = (value instanceof Array) ? value.join(", ") : value;

	var id = "current" + name.substring(0,1).toUpperCase() + name.substring(1);
	var valueEl = Util.$(id);
	var labelEl = Util.$(name + "Label");

	if (value)
	{
		valueEl.innerHTML = spanWithText(value);
		Util.showElement(valueEl);

		if (labelEl)
			Util.showElement(labelEl);
	}
	else
	{
		Util.hideElement(valueEl);

		if (labelEl)
			Util.hideElement(labelEl);
	}
}

//---------------------------------------------------------------------------------------
function spanWithText(text) { return "<span>" + text + "</span>"; }

//---------------------------------------------------------------------------------------
function populateInfoPaneWithTheaterInfo(theater)
{
	Util.$("currentTheaterName").innerHTML 	= theater.name;

	if (theater.address)
	{
		Util.$("currentTheaterStreet").innerHTML = theater.address.street;
		Util.$("currentTheaterCity").innerHTML 	= theater.address.city;
		Util.$("currentTheaterState").innerHTML 	= theater.address.state;
		Util.$("currentTheaterZip").innerHTML 	= theater.address.postal_code;
		Util.$("currentTheaterPhone").innerHTML 	= theater.tel;
	}
	
	Util.$("currentTheaterAddress").onclick 		= function () { widget.openURL(theater.mapUrl); };	
	
	var kTicketGraphicHeight = 82;
	
	// center the theater name vertically
	var currentTicketTitle = Util.$("currentTicketTitle");
	currentTicketTitle.innerHTML = theater.name;
	var style = document.defaultView.getComputedStyle(currentTicketTitle, "");
	var theaterNameHeight = parseInt(style.getPropertyValue("height"), 10);
	var posY = (kTicketGraphicHeight - theaterNameHeight) / 2 + 5;
	currentTicketTitle.style.top = posY + "px";

	var html = "";
	
	if (theater.features && theater.features.length)
		for (var i = 0; i < theater.features.length; i++)
			html += "<li>" + theater.features[i] + "</li>";
	
	Util.$("currentTheaterFeatures").innerHTML = html;
}

//---------------------------------------------------------------------------------------
function setBuyTicketsButtonEnabled(yn)
{
	Util.$("ticketsButton").className = (yn) ? "enabledActionButton" : "disabledActionButton";
}

//---------------------------------------------------------------------------------------
function theaterInfoButtonClicked(evt)
{
	var li = Util.getFirstAncestorOrSelfByTagName(evt.target, "li");

	gCurrTheaterID = li.id;
	Util.consumeEvent(evt);

	if (Util.isShowing(gTrailerPane))
		stopMovie(showTheaterInfo);
	else if (Util.isShowing(gTheaterPane))
	{
		if (gSortByMovies)
			hideBottomPane(showMovieInfo);
		else
		{
			if (gBrowser)
			{
				if (gBrowser.path().length == 1)
					hideBottomPane(showMovieInfo);
				else
				{
					hideBottomPane();
					Util.hideElement(gTheaterPane);
				}
			}
		}
	}
	else
		hideBottomPane(showTheaterInfo);
}

//---------------------------------------------------------------------------------------
function showTheaterInfo(fade)
{	
	Util.showElement(gBottomPane);
	Util.showElement(gTheaterPane);
	Util.hideElement(gMoviePane);
	Util.hideElement(gTrailerPane);

	var theater = boxOffice.Theater.getTheaterObjs()[gCurrTheaterID];

	populateInfoPaneWithTheaterInfo(theater);
	showBottomPane(fade);
}

//---------------------------------------------------------------------------------------
function showMovieInfo(fade)
{

	Util.hideElement(gTheaterPane);
	Util.hideElement(gTrailerPane);
	
	Util.showElement(gBottomPane);
	Util.showElement(gMoviePane);
	
	populateInfoPaneWithMovieInfo();
	setUpCurrentInfoScrollbars();
	showBottomPane(fade);
	
	resizeWidgetForTrailerHeightAndCallback(204, null);
	
}

//---------------------------------------------------------------------------------------
function showTrailer()
{
	Util.showElement(gBottomPane);
	Util.hideElement(gMoviePane);
	Util.hideElement(gTheaterPane);
	Util.showElement(gTrailerPane);
	showBottomPane();
	
	var	movieObjs = boxOffice.Movie.getMovieObjs();
	var trailerHeight = movieObjs[gCurrMovieID].trailer.height;

	resizeWidgetForTrailerHeightAndCallback(trailerHeight, loadMovie);
}


//---------------------------------------------------------------------------------------
// #mark ========== Click Actions ==========
//---------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------
function trailerButtonClicked(evt)
{
	if (Util.$("trailerButton").className.indexOf("disabled") != -1)
		return;

	hideBottomPane(showTrailer, true);
}

//---------------------------------------------------------------------------------------
function backButtonClicked(evt)
{
	stopMovie(function(){showMovieInfo(true)});
	
	if (gBrowser)
		gBrowser.focus();
}

//---------------------------------------------------------------------------------------
function ticketsButtonClicked(evt)
{
	if (Util.$("ticketsButton").className == "disabledActionButton" || !window.widget)
		return;
	
	var theaters = boxOffice.Theater.getTheaterObjs();
    var path     = gBrowser.path();
    var rowIdx   = null;
	var theater  = theaters[gCurrTheaterID];
	var tmsid 	 = theater.id;
	var movies	 = boxOffice.Movie.getMovieObjs();
	var movie 	 = movies[gCurrMovieID];
	var movieId	 = movie.fandango_id;
    var time     = null;
    var url;
    
    if ( path.length > 2 )
    {
        time = movie.times[gCurrTheaterID][rowIdx];
    }
    else
    {
    	movies = boxOffice.Theater.moviesForTheater(theater);
    	time = movies[gCurrMovieID].times[0];
    }
        
    time.date = theater.show_date;
	url = getTicketPurchasePageUrl(movieId, tmsid, time);

	widget.openURL(url);
}

//---------------------------------------------------------------------------------------
function moviesButtonClicked(evt)
{
	Util.consumeEvent(evt);

	if (gSortByMovies)
		return;

	Util.removeClassName(Util.$("theatersButton"), "selected");
	Util.addClassName(Util.$("moviesButton"), "selected");
	switchSortByMethod();
}

//---------------------------------------------------------------------------------------
function theatersButtonClicked(evt)
{
	if ( !gCurrTheaterID )
		gCurrTheaterID = boxOffice.Theater.getTheaterKeys()[0];
		
	Util.consumeEvent(evt);
	
	if (!gSortByMovies)
		return;

	Util.removeClassName(Util.$("moviesButton"), "selected");
	Util.addClassName(Util.$("theatersButton"), "selected");
	switchSortByMethod();
}

function switchSortByMethod()
{
	if (Util.isShowing(gTrailerPane))
		stopMovie(doSwitchSortbyMethod);
	else
		doSwitchSortbyMethod();
}

function doSwitchSortbyMethod()
{
	gSortByMovies = !gSortByMovies;
	
	var path = gBrowser.path();
	
	populateBrowserInfo();
	makeBrowserSelections(path);
}

function makeBrowserSelections(path)
{
	var movieKeys = boxOffice.Movie.getMovieKeys(),
		movieObjs = boxOffice.Movie.getMovieObjs(),
		
		theaterKeys = boxOffice.Theater.getTheaterKeys(),
		theaterObjs = boxOffice.Theater.getTheaterObjs();

//	var movie = movieObjs[movieKeys[gCurrMovieIdx]];
	var movie = movieObjs[gCurrMovieID];
	var theater = theaterObjs[gCurrTheaterID];
	
	var objIndex = 0;
	var column0RowIndex = movieKeys.indexOf(gCurrMovieID);
	var column1RowIndex = -1;
	var column2RowIndex = -1;

	if ( !gSortByMovies )
	{
		column0RowIndex = theaterKeys.indexOf(gCurrTheaterID);
	}

	gBrowser.selectRowInColumn(column0RowIndex, 0);
	
	if (!path)
		path = gBrowser.path();
		
	if (gSortByMovies)
	{
		// column1 index should be index of selected theater in theaters for movie				
		var theatersForMovie = boxOffice.Movie.theatersForMovie(movie.tms_id);
		column1RowIndex = theatersForMovie.indexOf(gCurrTheaterID);
	}
	else
	{
		// column1 index should be index of selected movie in movies for theater		
		var movieKeys = boxOffice.Theater.movieKeysForTheater(theaterObjs[gCurrTheaterID]);
		column1RowIndex = movieKeys.indexOf(movie.tms_id);
	}

	if (column1RowIndex > -1)
		gBrowser.selectRowInColumn(column1RowIndex, 1);

	
/*	if (p > 2)
	{
		var times = movie.times[gCurrTheaterID];

		for (var i = 0; i < times.length; i++)
			if (times[i].id == gCurrTimeID)
			{
				column2RowIndex = i;
				break;
			}

		if (column2RowIndex > -1)
			gBrowser.selectRowInColumn(column2RowIndex, 2);
			
	}
	*/
}

function topbarClicked(evt)
{
	Util.consumeEvent(evt);
	
	if ("topbarClickRegion" != evt.target.id)
		return;

	var isSlowMo = evt.shiftKey;
	
	shrinkWidget(isSlowMo);
}

function shrinkWidget(isSlowMo)
{
	removeTopbarEventListener();

	var isReverse = true;

	resizePhase4(isSlowMo, isReverse);
	clearFront(null, true);
}

function logoClicked(evt)
{
	if (window.widget)
		widget.openURL(Util.getLocalizedString("http://fandango.com"));
}

function getDate()
{
	var date = Util.$("dateSelect").value;

	if (!date)
		date = serializedStringForDate(new Date());

	return (date);
}

function getLocation()
{
	return (preferenceForKey(LOCATION_KEY));
}

function randomIntegerZeroToNInclusive(n)
{
	return (Math.floor((Math.random()*new Date().getTime()) % n));
}

//	function appleHasResourcesForMovie(movieInfoEl) {
//		var posterEls = movieInfoEl.getElementsByTagName("poster");
//		return posterEls && posterEls.length;
//	}

function populateBrowserInfo()
{
	if (!gBrowser)
		gBrowser = new AppleBrowser(Util.$("browser"), new MyBrowserDelegate());
	
	gBrowser.clearAllColumns();
	gBrowser.renderColumn(0);
	addTopbarEventListener();
	gBrowser.focus();
}

function addTopbarEventListener()
{
	Util.$("topbarClickRegion").addEventListener("click", topbarClicked, false);
	Util.$("moviesButton").addEventListener("click", moviesButtonClicked, false);
	Util.$("theatersButton").addEventListener("click", theatersButtonClicked, false);
}

function removeTopbarEventListener()
{
	Util.$("topbarClickRegion").removeEventListener("click", topbarClicked, false);
	Util.$("moviesButton").removeEventListener("click", moviesButtonClicked, false);
	Util.$("theatersButton").removeEventListener("click", theatersButtonClicked, false);
}

function documentKeyDown(evt)
{
	if (!Util.isShowing(Util.$("front"))) return;
	
	if (isInCompactView())
	{ 
		if (evt.keyCode == 13 || evt.keyCode == 32)
		{	//	return or spacebar
			posterClicked(evt);
			Util.consumeEvent(evt);
		}
	}
	else if (Util.isShowing(gTrailerPane))
	{
		if (evt.keyCode == 32)
		{	//	spacebar
			playPause(evt);
			Util.consumeEvent(evt);
		}
		else if (evt.keyCode == 27)
		{	//	esc
			backButtonClicked(evt);
			Util.consumeEvent(evt);
		}
	}
	else if (evt.keyCode == evt.metaKey && 49)
	{	//	cmd-1
		moviesButtonClicked(evt);
		Util.consumeEvent(evt);
	}
	else if (evt.keyCode == evt.metaKey && 50)
	{	//	cmd-2
		theatersButtonClicked(evt);
		Util.consumeEvent(evt);
	}
	else if (evt.keyCode == 13 || evt.keyCode == 32)
	{	//	return or spacebar
		if (gCurrMovieID && !playing)
		{
			trailerButtonClicked(evt);
			Util.consumeEvent(evt);
		}
	}
}

//---------------------------------------------------------------------------------------
// #mark ======== Trailer Playing and Updating ==========
//---------------------------------------------------------------------------------------
// functions used for setting up and controller trailer playback

//	Movie trailer stuff
const SLIDER_WIDTH = 353;
const SLIDER_LEFT  = 136;

var playing;
var gSlider;
var sliderUpdateIntervalId;
var movieDownloadingIntervalId;
var progressIndicatorWidth;

//---------------------------------------------------------------------------------------
function loadMovie()
{
	gBrowser.blur();
	Util.showElement(gTrailerPane);
	
	// set up controls if not already
	if ( !gSlider )
		setupSlider();
		
	// set the movie src
	updateMovieElement();
	
	playing = true;
	updatePlayPauseButton();

//	movieDownloadingIntervalId = setInterval("movieDownloadingUpdate();",20);
}

//---------------------------------------------------------------------------------------
function updateMovieElement()
{
	var movies = boxOffice.Movie.getMovieObjs();
	var trailerInfo = movies[gCurrMovieID].trailer;
	var movieEl = Util.$("movie");
//	var posterURL = movies[gCurrMovieID].poster;
	
//	if ( posterURL.length )
	{
//		posterURL = "http://trailers.apple.com" + posterURL;
	}
	
	movieEl.setAttribute("src", trailerInfo.url);
//	movieEl.setAttribute("poster", posterURL);
	movieEl.setAttribute("height", trailerInfo.height);
}

//---------------------------------------------------------------------------------------
function setupSlider()
{
	if (gSlider)
	{
		gSlider.setValue(0);
		gSlider.refresh();
		return;
	}
	var trailerSlider = Util.$("trailerSlider");
	var movieController = Util.$("movie");
	var thumbURL;
	if (window.devicePixelRatio > 1)
		thumbURL = "img/_video_cntl/__trackthumb@2x.png";
	else
		thumbURL = "img/_video_cntl/__trackthumb.png";

	gSlider = new AppleHorizontalSlider(Util.$("trailerSlider"), null);
	gSlider.continuous = true;
	gSlider.setTrackStart(null, SLIDER_WIDTH);
	gSlider.setTrackMiddle(null, 0);
	gSlider.setTrackEnd(null, 0);
	gSlider.setThumb(thumbURL, 17);
	gSlider._thumb.style.zIndex = 10;
	
	// register for events
	Util.$("trailerProgressIndicator").addEventListener("mousedown", sliderTrackMouseDownCapturePhase, true);
	Util.$("trailerSlider").addEventListener("mousedown", trailerSliderMouseDownCapturePhase, true);
	document.addEventListener("mouseup", documentMouseUpCapturePhase, true);
	document.addEventListener("mousedown", documentMouseDownBubblePhase, false);
	
	movieController.addEventListener( "progress", movieDownloadProgressUpdated, false);
	movieController.addEventListener( "canplaythrough", movieCanPlayThroughUpdated, false);
	movieController.addEventListener( "timeupdate", movieTimeUpdated, false);
	movieController.addEventListener( "ended", movieEnded, false);

}

//---------------------------------------------------------------------------------------
function playPause(evt) 
{
	Util.consumeEvent(evt);

	if (playing)
	{
		Util.$("movie").pause();
	}
	else
	{
		gBrowser.blur();
		Util.$("movie").play();
	}

	playing = !playing;
	updatePlayPauseButton();
}

//---------------------------------------------------------------------------------------
function updatePlayPauseButton() 
{
	Util.$("trailerControls").className = (playing) ? "playing":"paused";
}

//---------------------------------------------------------------------------------------
function stopMovie(callback)
{
	playing = false;

	if (gSlider)
	{
		gSlider.setValue(0);
		gSlider.refresh();
	}

	var movieController = Util.$("movie");
	
	if (movieController && !movieController.paused)
		movieController.pause();

	callback();
}



//---------------------------------------------------------------------------------------
// #mark ======== Slider Event Handling ==========
//---------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------
function sliderTrackMouseDownCapturePhase(evt) { gSlider._mousedownTrackHandler(evt); }

//---------------------------------------------------------------------------------------
function trailerSliderMouseDownCapturePhase(evt)
{
	if (eventTargetIsPlayPauseButton(evt) || eventTargetIsMovie(evt))
		return;

	if ( window.devicePixelRatio > 1)
		gSlider.setThumb("img/_video_cntl/__scrubthumbInny@2x.png", 18);
	else
		gSlider.setThumb("img/_video_cntl/__scrubthumbInny.png", 18);
		
	gSlider.refresh();
	Util.$("movie").pause();
	gSlider.onchanged = sliderChanged;
}

//---------------------------------------------------------------------------------------
// done tracking
function documentMouseUpCapturePhase(evt)
{
	if (eventTargetIsPlayPauseButton(evt))
		return;

	if (playing)
		Util.$("movie").play();
		
	gSlider.onchanged = null;
	if ( window.devicePixelRatio > 1)
		gSlider.setThumb("img/_video_cntl/__trackthumb@2x.png", 17);
	else
		gSlider.setThumb("img/_video_cntl/__trackthumb.png", 17);
}

//---------------------------------------------------------------------------------------
function documentMouseDownBubblePhase(evt)
{
	if (eventTargetIsMovie(evt))
	{
		playPause();
		Util.consumeEvent(evt);
	}
}

//---------------------------------------------------------------------------------------
function sliderChanged(currentValue)
{
	var movieController = Util.$("movie");
	movieController.currentTime = (movieController.duration * currentValue);
}

//---------------------------------------------------------------------------------------
// override AppleHorizontalSlider instance method so that you can't drag the slider beyond 
// the current max movie loaded progress point.
AppleHorizontalSlider.prototype._getMousePosition = function(event)
{
	if (event != undefined)
	{
		var maxX = progressIndicatorWidth + SLIDER_LEFT;
		
		return (event.x > maxX ? maxX : event.x);
	}
	else
		return (0);
}


//---------------------------------------------------------------------------------------
function updateSlider()
{
	var movieController = Util.$("movie");
	var currentTime = movieController.currentTime;
	var endTime = movieController.duration;

	if (currentTime >= endTime)
	{ // check to see if the movie has ended.
		movieEnded();
		return;
	}
	gSlider.setValue(currentTime/endTime);
}

//---------------------------------------------------------------------------------------
function eventTargetIsPlayPauseButton(evt) { return (evt.target.id == "playButton"); }

//---------------------------------------------------------------------------------------
function eventTargetIsMovie(evt) { return (evt.target.id == "movie"); }


//---------------------------------------------------------------------------------------
// #mark ======== Movie Event Handling ==========
//---------------------------------------------------------------------------------------
/*
	movieController.addEventListener( "progress", movieDownloadProgressUpdated, false);
	movieController.addEventListener( "canplaythrough", movieCanPlayThroughUpdated, false);
	movieController.addEventListener( "timeupdate", movieTimeUpdated, false);
	movieController.addEventListener( "ended", movieEnded, false);
*/

//---------------------------------------------------------------------------------------
// update trailerProgressIndicator
function movieDownloadProgressUpdated()
{
	var progressIndicator = Util.$("trailerProgressIndicator");
	var movieController = Util.$("movie");
	
	ratio = movieController.buffered.end() / movieController.duration;
	progressIndicatorWidth = parseInt(SLIDER_WIDTH*ratio);
	progressIndicator.style.width = progressIndicatorWidth + "px";

}

//---------------------------------------------------------------------------------------
// start playback if not playing
function movieCanPlayThroughUpdated()
{
	var movieController = Util.$("movie");
	if ( movieController.paused && playing)
		movieController.play();
		
}

//---------------------------------------------------------------------------------------
// update slider
function movieTimeUpdated()
{
	updateSlider();
}

//---------------------------------------------------------------------------------------
// reset slider and time
function movieEnded()
{
	playing = false;
	updatePlayPauseButton();
	gSlider.setValue(0);
	gSlider.refresh();
	Util.$("movie").pause();
	Util.$("movie").currentTime = 0;
}


//---------------------------------------------------------------------------------------
// #mark ======== Resize methods for Trailer ==========
//---------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------
function widgetHeightForTrailerHeight(trailerHeight)
{
	if (parseInt(trailerHeight) <= 204)
		return (FRONT_EXPANDED_HGHT);	// -1, 200, 204
	else	
		return (parseInt(trailerHeight) + 214);	// 224, 228, 260, 272, 360
}

//---------------------------------------------------------------------------------------
function resizeWidgetForTrailerHeightAndCallback(trailerHeight, callback)
{	
	if ( callback )
		Util.hideElement(gTrailerPane);
	
	var widgetHeight = widgetHeightForTrailerHeight(trailerHeight);
	
	var timer = new AppleAnimator(300, ANIM_FRAME_RATE);
	var startHeight = parseInt(Util.$("front").style.height);
	var startRect = new AppleRect(0, 0, 0, startHeight);
	var finishRect = new AppleRect(0, 0, 0, widgetHeight);
	var frontAnime = new AppleRectAnimation(startRect, finishRect, resizeWidgetForTrailerHandler);

	timer.addAnimation(frontAnime);

	var isGrowing = startHeight < widgetHeight;
	timer.oncomplete = function() { resizeWidgetForTrailerCompleteHandler(widgetHeight, callback, isGrowing); };

	if (isGrowing)
		if (window.widget)
			widget.resizeAndMoveTo(screenX, screenY, window.innerWidth, widgetHeight);

	timer.start();
}

//---------------------------------------------------------------------------------------
function resizeWidgetForTrailerHandler(rectAnime, currentRect, startRect, finishRect)
{
	Util.$("front").style.height = parseInt(currentRect.bottom) + "px";
}

//---------------------------------------------------------------------------------------
function resizeWidgetForTrailerCompleteHandler(widgetHeight, callback, isGrowing)
{
	Util.$("front").style.height = widgetHeight + "px";

	if (!isGrowing)
		if (window.widget)
			widget.resizeAndMoveTo(screenX, screenY, window.innerWidth, widgetHeight);
	
	if (callback)
		callback();
}


//---------------------------------------------------------------------------------------
// #mark ======== Browser Updating ==========
//---------------------------------------------------------------------------------------
// functions used for updating the browser cells

//---------------------------------------------------------------------------------------
function addMovieToCell(movie, cell, rowIdx)
{
	cell.id = movie.tms_id;

	cell.innerHTML = "<span class='title'>"
		+ stringByRemovingDashes(movie.title)
		+ "</span><span class='rating'>" + (movie.rating ? movie.rating : "") + "</span>";
}

//---------------------------------------------------------------------------------------
function addTheaterToCell(theater, cell, rowIdx)
{
	cell.id = theater.id;

	var html = "<span class='theater'>" 
		+ stringByRemovingDashes(theater.name)
		+ "</span>";
	
	if (gSortByMovies)
		html += "<button class='theaterInfo' onmousedown='theaterInfoButtonClicked(event);'></button>";

	cell.innerHTML = html;
}

//---------------------------------------------------------------------------------------
function addTimeToCell(time, cell, rowIdx)
{
	cell.id = time.id;
	cell.innerHTML = "<span class='time'>" + time.time + "</span>";
}

//---------------------------------------------------------------------------------------
function movieWasSelectedInBrowser()
{
	if (Util.isShowing(gTrailerPane))
		stopMovie(function(){showMovieInfo(true)});
	else
		showMovieInfo();

	setBuyTicketsButtonEnabled(!gSortByMovies);
}

//---------------------------------------------------------------------------------------
function theaterWasSelectedInBrowser()
{
	var callback = (gSortByMovies) ? showMovieInfo : showTheaterInfo;
	
	if (Util.isShowing(gTrailerPane))
	{
		callback = gSortByMovies ? function() { showMovieInfo(true) } : function() { showTheaterInfo(true) }

		stopMovie(callback);
	}
	else if (Util.isShowing(gMoviePane))
	{
		if (!gSortByMovies)
			hideBottomPane(callback);

	}
	else if (Util.isShowing(gTheaterPane))
	{
		var theaters = boxOffice.Theater.getTheaterObjs();
		populateInfoPaneWithTheaterInfo(theaters[gCurrTheaterID]);
	}
	else
		callback();

	setBuyTicketsButtonEnabled(gSortByMovies);
}

//---------------------------------------------------------------------------------------
function timeWasSelectedInBrowser()
{
	var theaters = boxOffice.Theater.getTheaterObjs();
	var theater = theaters[gCurrTheaterID];

	setBuyTicketsButtonEnabled(true);
}

//---------------------------------------------------------------------------------------
// #mark ======= Browser Callbacks ========
//---------------------------------------------------------------------------------------
// functions used by the browser


function MyBrowserDelegate() {}

//---------------------------------------------------------------------------------------
MyBrowserDelegate.prototype.labelForColumn = function(browser, colIndex)
{
	var s = '';
	if ( gColumnLabels && gColumnLabels[colIndex]) s = Util.getLocalizedString(gColumnLabels[colIndex]);
	return s;
}

//---------------------------------------------------------------------------------------
MyBrowserDelegate.prototype.willDisplayCellAtRowColumn = function(browser, cell, rowIdx, colIdx)
{
	var movieObjs = boxOffice.Movie.getMovieObjs();
	var movieKeys = boxOffice.Movie.getMovieKeys();
	var theaterObjs = boxOffice.Theater.getTheaterObjs();
	var theaterKeys = boxOffice.Theater.getTheaterKeys();
	var	movie;
	var	theater;
	var theatersForMovie;

	if (colIdx == 0)
	{
		if (gSortByMovies)
		{	
			movie = movieObjs[movieKeys[rowIdx]];
			
			addMovieToCell(movie, cell, rowIdx);
		}
		else
		{
			theater = theaterObjs[theaterKeys[rowIdx]];
			
			addTheaterToCell(theater, cell, rowIdx);
		}
	}
	else if (colIdx == 1)
	{
		if (gSortByMovies)
		{
			theatersForMovie = boxOffice.Movie.theatersForMovie(gCurrMovieID);
			theater = theatersForMovie[rowIdx];
			
			addTheaterToCell(theater, cell, rowIdx);
		}
		else
		{
			var movies = boxOffice.Theater.moviesForTheater(theaterObjs[gCurrTheaterID]);
			var movieKeys = boxOffice.Theater.movieKeysForTheater(theaterObjs[gCurrTheaterID]);
			movie = movies[movieKeys[rowIdx]];
			
			addMovieToCell(movie, cell, rowIdx);
		}
	}
	else if (colIdx == 2)
	{
		var movies = boxOffice.Theater.moviesForTheater(theaterObjs[gCurrTheaterID]);
		movie = movies[gCurrMovieID];

		if ( movie )
		{
			time = movie.times[rowIdx];
			addTimeToCell(time, cell, rowIdx);
		}
	}
	else
		return (0);
};

//---------------------------------------------------------------------------------------
MyBrowserDelegate.prototype.numberOfRowsInColumn = function(browser, colIdx)
{
	var movieKeys = boxOffice.Movie.getMovieKeys(),
		movieObjs = boxOffice.Movie.getMovieObjs(),
		
		theaterKeys = boxOffice.Theater.getTheaterKeys(),
		theaterObjs = boxOffice.Theater.getTheaterObjs();

	if (movieObjs && movieObjs && theaterKeys && theaterObjs)
	{
		if (colIdx == 0)
			return (gSortByMovies ? movieKeys.length : theaterKeys.length);
		else
		{
			var movie = movieObjs[gCurrMovieID];
			var theater = theaterObjs[gCurrTheaterID];		

			if (colIdx == 1)
			{
				if ( gSortByMovies )
				{
					return boxOffice.Movie.theatersForMovie(gCurrMovieID).length;
				}
				else
				{
					return boxOffice.Theater.movieKeysForTheater(theater).length;
				}
			}
			else if (colIdx == 2)
			{
				
				var movies = boxOffice.Theater.moviesForTheater(theater);
				movie = movies[gCurrMovieID];
			
				var times = movie.times;

				return (times ? times.length : 0);
			}
			else
				return (0);
		}
	}
};

//---------------------------------------------------------------------------------------
MyBrowserDelegate.prototype.selectRowInColumn = function(browser, rowIdx, colIdx)
{
	var movieKeys = boxOffice.Movie.getMovieKeys(),
		movieObjs = boxOffice.Movie.getMovieObjs(),
		
		theaterKeys = boxOffice.Theater.getTheaterKeys(),
		theaterObjs = boxOffice.Theater.getTheaterObjs();

	if (colIdx == 0)
	{
		if (gSortByMovies)
		{
			gCurrTheaterID = null;
//			gCurrMovieIdx = rowIdx;
			gCurrMovieID = movieKeys[rowIdx];
			movieWasSelectedInBrowser();
		}
		else
		{
//			gCurrMovieIdx = null;
			gCurrMovieID = null;
			gCurrTheaterID = theaterKeys[rowIdx];
			theaterWasSelectedInBrowser();
		}
	}
	else if (colIdx == 1)
	{
		var cell = browser.selectedCellInColumn(colIdx);
		var id = cell.id;

		if (gSortByMovies)
		{
			gCurrTheaterID = id;
			theaterWasSelectedInBrowser();
		}
		else
		{
//			gCurrMovieIdx = id;
			gCurrMovieID = id;
			movieWasSelectedInBrowser();
		}
	}
	else if (colIdx == 2)
	{
	//	var movie = allMoviesTable[gCurrMovieIdx]; 
	//	currentTimeId = movie.times[gCurrTheaterID][rowIdx].id;
		timeWasSelectedInBrowser();
	}
};

//---------------------------------------------------------------------------------------
MyBrowserDelegate.prototype.scrollbarForDiv = function(scrollbarDiv)
{
	var scrollbar = new AppleVerticalScrollbar(scrollbarDiv);
	scrollbar.setSize(7);
	
	if ( window.devicePixelRatio > 1 )
	{
		scrollbar.setTrackStart("img/_scroll/_track_top@2x.png", 7);
		scrollbar.setThumbStart("img/_scroll/browser_top@2x.png", 4);
		
		scrollbar.setTrackMiddle("img/_scroll/_track_mid@2x.png", 1);
		scrollbar.setThumbMiddle("img/_scroll/browser_mid@2x.png", 1);
		
		scrollbar.setTrackEnd("img/_scroll/_track_btm@2x.png", 7);
		scrollbar.setThumbEnd("img/_scroll/browser_btm@2x.png", 4);
	}
	else
	{
		scrollbar.setTrackStart("img/_scroll/_track_top.png", 7);
		scrollbar.setThumbStart("img/_scroll/browser_top.png", 4);
		
		scrollbar.setTrackMiddle("img/_scroll/_track_mid.png", 1);
		scrollbar.setThumbMiddle("img/_scroll/browser_mid.png", 1);
		
		scrollbar.setTrackEnd("img/_scroll/_track_btm.png", 7);
		scrollbar.setThumbEnd("img/_scroll/browser_btm.png", 4);
	}

	return (scrollbar);
};

//	City/State Validation *************/
//---------------------------------------------------------------------------------------
// #mark ======= City/State Validation ========
//---------------------------------------------------------------------------------------
// functions used validate the location

var validateTypingTimer;
var validateTimerData = null;
var locationValidated = false;

//---------------------------------------------------------------------------------------
function locationChanged()
{
	var newLocation = escape(Util.$("locationTextField").value);

	// validate this entry if it's not a zip, which don't get results anyways because they are exact
	if (!isValidPostalCode(newLocation))
	{
		validateLocation(newLocation);
		// start the the validate timer
		Util.$("validateLabel").innerHTML = Util.getLocalizedString("Validating");
		clearValidationTimer();
		validateTimerData = {timer:setInterval(validateTimer, 500), pos:-1};		
	}
}

//---------------------------------------------------------------------------------------
// We capture Delete in the keypress handler, but it might cause the text to change,
// which results in an input event as well.
var shouldIgnoreInputEvent = false;

//---------------------------------------------------------------------------------------
function locationTextFieldKeyPressed(evt)
{
    shouldIgnoreInputEvent = false;
    dismissValidation();
        
    var location = Util.$("locationTextField").value;

	switch (evt.keyCode)
	{
		case 13: // return
		case 3:  // enter
			if (locationValidated || isValidPostalCode(location))
			{
				showFront();
				break;
			}
			
			if (isFinite(location) && !isValidPostalCode(location))
			{
				showMenuItem(Util.getLocalizedString("Invalid Zip Code."));
				
				return;
			}
			// intentional fall-thru
		case 9:  // tab
			if (!locationValidated)
			{
				// immediate validation
				if (location.length > 0)
				{
					locationChanged();
				}
			} 
		break;
		case 8: // delete
			shouldIgnoreInputEvent = true;  // don't trigger delayed validation
			locationValidated = false;                
		break;
		default:
			locationValidated = false;                
	}
}

//---------------------------------------------------------------------------------------
function locationTextFieldTyping(evt)
{
	if (!shouldIgnoreInputEvent)
	{
		// delayed validation
		var location = Util.$("locationTextField").value;

		if (location.length > 0)
			validateTypingTimer = setTimeout(locationChanged, 950);
	}
	
	shouldIgnoreInputEvent = false;
}

//---------------------------------------------------------------------------------------
function dismissValidation()
{
	if (validateTypingTimer)
	{
		clearTimeout(validateTypingTimer);
		validateTypingTimer = null;
	}

	clearValidationTimer();
	validationObject = null;
	Util.hideElement('validateLabel');
}

//---------------------------------------------------------------------------------------
function clearValidationTimer()
{
	if (validateTimerData)
	{
		clearInterval(validateTimerData.timer);
		validateTimerData = null;
	}
}

//---------------------------------------------------------------------------------------
function selectAllInLocationTextField()
{
	var textField = Util.$("locationTextField");

	textField.focus();
	textField.select();
}

//---------------------------------------------------------------------------------------
function validateTimer()
{
	try
	{
		Util.showElement('validate');

		if (++validateTimerData.pos > 4)
			validateTimerData.pos = 0;

		var text = Util.getLocalizedString("Validating");

		for (var i = 0; i < validateTimerData.pos; ++i)
			text += '.';

		Util.$("validateLabel").innerHTML = text;
		
	}
	catch (e)
	{
		clearValidationTimer();
	}
}

//---------------------------------------------------------------------------------------
var validationObject = null;

//---------------------------------------------------------------------------------------
function validationCallbackDelayed()
{
	var menu = (window.widget ? widget.createMenu() : null);
	
	if (validationObject.error || validationObject.cities.length <= 0)
	{
		if (menu)
		{
			menu.addMenuItem(Util.getLocalizedString("No cities found"));
			menu.setMenuItemEnabledAtIndex(0, false);
		}
	}
	else
	{
		var c =  validationObject.cities.length;
		
		if (c == 1 || !window.widget)
		{
			// just set the contents if their is only one city.
			var city = validationObject.cities[0];
			var textField = Util.$("locationTextField");
			textField.value = city.city + ", " + city.state;
			gCurrPostalCode = city.postal;
			locationValidated = true;
			menu = null;
		}
		else
		{
			for (var i = 0; i < c; ++i)
			{
				var city = validationObject.cities[i];

				menu.addMenuItem(city.city + ", " + city.state);
			}
		}
	}
	
	if (menu)
	{
		var selectedItem = menu.popup(252, 107);

		if (selectedItem >= 0)
		{
			var city = validationObject.cities[selectedItem];
			var textField = Util.$("locationTextField");

			textField.value = city.city + ", " + city.state;
			gCurrPostalCode = city.postal;
			locationValidated = true;
			textField.select();
		}
	}
	validationObject = null;
}

//---------------------------------------------------------------------------------------
function validationCallback(object)
{
    dismissValidation();
	
	if (Util.isShowing(Util.$("back")))
	{	
		// force a redraw before we present a menu, otherwise the 
		// validating text will not disappear.
		validationObject = object;
		setTimeout(validationCallbackDelayed, 0);
	}
}


