

var _gWaitingForMoviesDataToLoad;
var _gAppleResourceUrlDoc;


stringByRemovingDashes.dashRegex = /-/g;
function stringByRemovingDashes(str)
{
	return (str.replace(stringByRemovingDashes.dashRegex, ""));
}

function containsObject(a, n) {
	for (var i = 0; i < a.length; i++) {
		if (a[i] == n) 
			return true;
	}
	return false;
}

//---------------------------------------------------------------------------------------
// #mark ======= Movie Info Parsing ========
//---------------------------------------------------------------------------------------
// functions used only by other parser functions

//---------------------------------------------------------------------------------------
// BoxOffice.Movie.fetchMovieInfo handler
function appleResourceUrlDataFetched(evt, req) 
{	
	_gAppleResourceUrlDoc = req.responseXML;
	parseAppleResourceUrlData();
	
	if (fetchAllData)
		setTimeout(fetchAllData, 200);
}

//---------------------------------------------------------------------------------------
// add movie info to the movie element
function consumeResourceUrlDataForMovie(movieInfoEl, movie) 
{
	var posterUrl = getTextContentOfFirstDescendantByTagName(movieInfoEl, "poster");
	if (posterUrl && posterUrl.length) 
	{
		movie.posterUrl = posterUrl;
		new Image().src = movie.posterUrl;
	}
	var previewEls = movieInfoEl.getElementsByTagName("preview");
	if (previewEls && previewEls.length) 
	{
		var previewEl = previewEls.item(0);
		movie.trailer = {
			url: previewEl.textContent,
			height: previewEl.getAttribute("height")
		};
	}
	
	// add contents of info element
	var infoEls = movieInfoEl.getElementsByTagName("info");
	if ( infoEls && infoEls.length)
	{
		var infoEl = infoEls.item(0);
		if ( infoEl )
		{
			movie.ratingPercent = getTextContentOfFirstDescendantByTagName(infoEl, "rating_percent");
			movie.ratingAverage = getTextContentOfFirstDescendantByTagName(infoEl, "rating_average");
			movie.cast = getTextContentOfFirstDescendantByTagName(infoEl, "cast");
			movie.directors = getTextContentOfFirstDescendantByTagName(infoEl, "directors");
			movie.genres = getTextContentOfFirstDescendantByTagName(infoEl, "genres");
			movie.synopsis = getTextContentOfFirstDescendantByTagName(infoEl, "summary");
			movie.rating = getTextContentOfFirstDescendantByTagName(infoEl, "rating");
			movie.releaseDate = movie.release_date;
			
			if (!movie.runtime) 
			{
				movie.runtime = getTextContentOfFirstDescendantByTagName(movieInfoEl, "runtime");
			}
		}
	}
}

//---------------------------------------------------------------------------------------
// add movie info to each movie item in the allMoviesTable
function parseAppleResourceUrlData() 
{

	var urlData;
	var fandangoID;
	var movie;

	try {
		urlData = _gAppleResourceUrlDoc;
		var movieInfoEl;
		var posterEls; 
		var previewEls;
		var movieInfoEls = urlData.getElementsByTagName("movieinfo");
				
		for (var i = 0; i < movieInfoEls.length; i++) 
		{
			movieInfoEl = movieInfoEls[i];
			fandangoID = movieInfoEl.getAttribute("fandangoid");
			movie = movieWithFandangoID(fandangoID);
			if (movie) 
			{
				consumeResourceUrlDataForMovie(movieInfoEl, movie);
				movie.complete = true;
			}
		}	
	} catch (e) {
		// ignore. if there's no poster or trailer resources, no biggie.
	} finally {
		urlData = null;
		_gAppleResourceUrlDoc = null;
	}
}

//---------------------------------------------------------------------------------------
// find the movie in movieObjs that has this fandangoID
function movieWithFandangoID ( fandangoID )
{
	if ( !fandangoID || (fandangoID.length == 0) )
		return null;
		
	// for each movieKey in movieObjs
	var movie = null;
	var movieKeys = BoxOffice.Movie.getMovieKeys();
	var movies = BoxOffice.Movie.getMovieObjs();
	
	for ( var key in movies )
	{
		if ( movies[key].fandango_id == fandangoID )
		{
			movie = movies[key];
			break;
		}
	}
	
	return movie;
}

//---------------------------------------------------------------------------------------
function fandangoIDForTheaterID( theaterId )
{
	var theaters = BoxOffice.Theater.getTheaterObjs();
	var theater = theaters[theaterId];
	
	return theater.now_showing[0].aa_code;
}

//---------------------------------------------------------------------------------------
function getTicketPurchasePageUrl(movieId, theaterId, time) {
	//"07-18-2007+22:25"
	// must create this format string. create lazily here, rather than during initial response parsing.
	var len = time.time.length-2;
	var isPM = ("pm" == time.time.substring(len));
	var timeStr = time.time.substring(0, len);
	var indexOfColon = timeStr.indexOf(":");
	var hours = parseInt(timeStr.substring(0, indexOfColon), 10);
	var mins = timeStr.substring(indexOfColon);
	theaterId = fandangoIDForTheaterID(theaterId);
	
	if (isPM) {
		if (hours < 12) {
			hours += 12;
			timeStr = hours + mins;
		}
	} else if (hours == 12) {
		timeStr = "00" + mins;
	}
	
	var dateStr = time.date.replace(/\//g, "-");
	var url = "http://wu.apple.com/redirect.aspx?&mid=" + movieId
	 	+ "&a=11617&tid=" + theaterId
	 	+ "&dte=0&date=" + dateStr
	 	+ "+"  + timeStr;
	
	return url;
}

//---------------------------------------------------------------------------------------
//	#mark ========== Location Validation ==========
//---------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------
function validateLocation(location, callback) 
{

	if (validateLocation.req) {
		validateLocation.req.abort();
		validateLocation.req = null;
	}
	
	if ( callback )
	{
		validateLocation.callback = callback;
	}
	else
	{
		validateLocation.callback = null;
	}
	
	var locStr = Util.$("locationTextField").value;
	var city = "";
	var state = "";
	
	var index = locStr.indexOf(",");

	if (-1 == index) {
		index = locStr.lastIndexOf(" ");
	}
	if (index > -1) {
		city = locStr.substring(0, index);
		state = locStr.substring(index+1);
	} else {
		city = locStr;
	}
	
//	var url = "http://where.yahooapis.com/geocode?city=" + city;
	var url = "http://gws2.maps.yahoo.com/findlocation?pf=1&appid=apple_placefinder&city=" + city;
	
	if (state != "")
	{
		url += "&state=" + state;
	}
	url += "&flags=J";
		
	var req = BoxOffice.prepareAsyncGetRequest(url, locationValidationFetched);
	validateLocation.req = req;
	req.send(null);
}

//---------------------------------------------------------------------------------------
function locationValidationFetched(evt, req) {
	var doc = JSON.parse( req.responseText );
	var result;
	
	if (!doc || doc.ResultSet.Error > 0) {
		result = {error:true};
	} else {
			var locationEls = doc.ResultSet.Results;
			result = {error:false, cities:new Array()};
	
			for (var i = 0; i < locationEls.length; i++) {
				var locationEl 	= locationEls[i];
				var city 	  	= locationEl.city;
				var state 	  	= locationEl.statecode;
				var country		= locationEl.country;
				var postalCode	= locationEl.uzip;
				result.cities.push({city:city, state:state, postal:postalCode, country:country});
			}
	}
	
	if ( validateLocation.callback )
	{
		// should only be one
		validateLocation.callback(result.cities[0].postal);
	}
	else
	{
		validationCallback(result);
	}
	req = doc = null;
}

//---------------------------------------------------------------------------------------
function setCurrPostalCode(postalCode)
{
	gCurrPostalCode = postalCode;
}

//---------------------------------------------------------------------------------------
//	#mark ========== BoxOffice ==========
//---------------------------------------------------------------------------------------
var BoxOffice; if (!BoxOffice) BoxOffice = {};

if (!BoxOffice.Movie) BoxOffice.Movie = {};
if (!BoxOffice.Theater) BoxOffice.Theater = {};

BoxOffice.instance = function() { return (this); }
BoxOffice.markForUpdate = function() { this.Movie._lastQueryDate = this.Theater._lastQueryDate = null; }

//---------------------------------------------------------------------------------------
BoxOffice.handleNetworkError = function() {

	alert("MOVIES NETWORK ERROR");

	Util.hideElement(Util.$("posterRollRgn"));

	if (!isInCompactView()) {
		showingErrorMsgBox = true;
		setTimeout(showErrorMsgBox, 2000);
		shrinkWidget();
	} else if (!showingErrorMsgBox) {
		showingErrorMsgBox = true;
		showErrorMsgBox();
	}
}

//---------------------------------------------------------------------------------------
BoxOffice.handleNoDataAvailable = function() {

	alert("NO MOVIE DATA AVAILABLE");

	if (isInCompactView()) {
		resizePhase1();
	} else{
		setTimeout(showBack, 600);
		setTimeout(function () {
			showMenuItem(getLocalizedString("No movie data available"));
		}, 1300);
	}
}

//---------------------------------------------------------------------------------------
BoxOffice.onHttpError = function(evt) {
	alert("Error occured while loading data: " + evt.target.status);
	handleNetworkError();
}

//---------------------------------------------------------------------------------------
BoxOffice.prepareAsyncGetRequest = function(url, successCallback) {

	Util.hideElement(Util.$("errorMsgBox"));

	var req = new XMLHttpRequest();

	req.onload = function(evt) {successCallback(evt, req)};
	req.onerror = this.onHttpError;
	url = encodeURI(url);
	req.open("GET", url, true);
	//	req.overrideMimeType("text/xml");
	req.setRequestHeader("Cache-control","No-cache");
	req.setRequestHeader("Pragma","No-cache");
	
	return (req);
}


//---------------------------------------------------------------------------------------
//	#mark ======== BoxOffice.Movie ========
//---------------------------------------------------------------------------------------
BoxOffice.Movie._obj = {};
BoxOffice.Movie._key = [];
BoxOffice.Movie._lastQueryDate = null;
BoxOffice.Movie._req = null;
BoxOffice.Movie._infoReq = null;
BoxOffice.Movie._selectedID = null;
BoxOffice.Movie._theaters = null;

//---------------------------------------------------------------------------------------
// used to sort the movies by title
function MovieTitleComparator(a, b)
{ 
	var A = a.title.toLowerCase();
	var B = b.title.toLowerCase();

	if (A < B) {
		return (-1);
	} else if (A > B) {
		return  (1);
	}

	return (0);
}

BoxOffice.Movie.getMovieObjs = function() { return (this._obj); }
BoxOffice.Movie.getMovieKeys = function() { return (this._key); }

//---------------------------------------------------------------------------------------
// return an array of theaters that a movie is showing at
BoxOffice.Movie.theatersForMovie = function ( movieID ) 
{
	var theaters = [];
	
	if ( ( this._selectedID == movieID ) && (this._theaters.length > 0) )
	{
		theaters = this._theaters;
	}
	else
	{
		var allTheaters;
		
		// get list of theaters
		allTheaters = BoxOffice.Theater.getTheaterObjs();
		
		// check each now_showing array for movie 
		for ( var theater in allTheaters )
		{
			var nowShowingList = allTheaters[theater].now_showing;
			for ( var i = 0; i < nowShowingList.length; i++ )
			{
				var movie = nowShowingList[i];
				if ( movie.tms_id == movieID )
				{
					// found the movie at this theater so add it to our list and stop checking
					// this theaters movies
					theaters.push(allTheaters[theater]);
					break;
				}
			}
		}
		this._selectedID = movieID;
		this._theaters = theaters;
	}
	return theaters;
}

//---------------------------------------------------------------------------------------
// parse the data returned from fetchMovieData
function movieDataFetched(evt, req) 
{
	var doc;
	try {
		doc = req.responseText;
		if (!doc) 
		{
			BoxOffice.handleNetworkError();
			return;
		}

		// reset key array
		BoxOffice.Movie._key.length = 0;
		BoxOffice.Movie._obj = {};
		BoxOffice.Movie._theaters = [];
		
		BoxOffice.Movie._lastQueryDate = new Date();

		//	call Safari's built-in JSON parser
		var raw = (new Function("return " + doc))();
		var movies = raw[0].pages[0];
		var	tm = [];	

		// all of the movies are in the now_showing arrays
		for (var i = 0;i < movies.length;i++) 
		{
			var	nowShowing = movies[i].now_showing

			for (var j = 0;j < nowShowing.length;j++) 
			{
				tm.push(nowShowing[j]);
			}
		}

		tm.sort(MovieTitleComparator);

		//	-------------------------------------
		function stringContains(subStr, str) {

			if (str.indexOf(subStr) > -1)
				return (true);

			return (false);
		}

		//	-------------------------------------
		function movieArrayContains(movieArray, aMovie)
		{
			for (var i in movieArray)
			{
				if (stringContains(movieArray[i].title, aMovie.title))
					return (true);
			}
	
			return (false);
		}

		// generate a unique set 
		for (var i = 0;i < tm.length;i++)
		{
			if (!movieArrayContains(BoxOffice.Movie._obj, tm[i]))
			{
				var	movieKey = tm[i].tms_id;
				
				BoxOffice.Movie._obj[movieKey] = tm[i];
				BoxOffice.Movie._key.push(movieKey)
			}
		}

		// load the movie info
		if ( !BoxOffice.Movie._infoReq )
		{
			BoxOffice.Movie.fetchMovieInfo();
		}

	} catch (e) {
		alert("Runtime Error: " + e);
		// handle missing network connection or no vendor data
		BoxOffice.handleNoDataAvailable();
	} finally {
		req = doc = null;
	}
}

//---------------------------------------------------------------------------------------
BoxOffice.Movie.fetchMovieData = function() {

	if (this._req) {
		this._req.abort();
		this._req = null;
	}
	
	// reset our data structures
	BoxOffice.Movie._infoReq = null;

	//	http://trailers.apple.com/trailers/global/scripts/showtimes.theaters.php?
	//	show_date=2011-6-20&items_per_page=5&postal_code=95124
	
	var url = "http://trailers.apple.com/trailers/global/scripts/showtimes.theaters.php?show_date="
		+ getDate() + "&items_per_page=20";

	if ( gCurrPostalCode )
		url += "&postal_code=" + gCurrPostalCode;
		
	// getMethodAndLocationQueryStringFragment();

	var req = BoxOffice.prepareAsyncGetRequest(url, movieDataFetched);
	
	this._req = req;

	this._req.send(null);
}

//---------------------------------------------------------------------------------------
BoxOffice.Movie.fetchMovieInfo = function() {

	if (this._infoReq) {
		this._infoReq.abort();
		this._infoReq = null;
	}
	
// TEMP - DEBUG - FIXME - for dev only using simulated data use the indexall on jktx3	
	var url = "http://www.apple.com/trailers/home/xml/widgets/indexall.xml" ;
//	var url = "http://localhost/~jeff/indexall.xml";

	var req = BoxOffice.prepareAsyncGetRequest(url, appleResourceUrlDataFetched);
	
	this._infoReq = req;

	this._infoReq.send(null);
}

//---------------------------------------------------------------------------------------
BoxOffice.Movie.shouldFetchNewMovieData = function() {
// return true if midnight (local time) has passed since data was last fetched
	if (!this._lastQueryDate) {
		return (true);
	}
	// getDate() returns day of month as number
	var midnightHasPassedSinceLastFetch = (new Date().getDate() != this._lastQueryDate.getDate());
	
	return (midnightHasPassedSinceLastFetch);
}


//	--------------------------------------
//	#mark ======== BoxOffice.Theater ========
//	--------------------------------------
BoxOffice.Theater._obj = {};
BoxOffice.Theater._key = [];
BoxOffice.Theater._lastQueryDate = null;
BoxOffice.Theater._req = null;
BoxOffice.Theater._selectedID = null;
BoxOffice.Theater._movies = {};
BoxOffice.Theater._movieKeys = [];

BoxOffice.Theater.getTheaterObjs = function() { return (this._obj); }
BoxOffice.Theater.getTheaterKeys = function() { return (this._key); }

//---------------------------------------------------------------------------------------
// this will update the keys and movie objects for the given theater - returns the keys
BoxOffice.Theater.movieKeysForTheater = function( theater ) 
{
	BoxOffice.Theater.moviesForTheater(theater);
	return (this._movieKeys); 
}

//---------------------------------------------------------------------------------------
// return the list of movies for a given theater
BoxOffice.Theater.moviesForTheater = function( theater )
{
	if ( !this._selectedID || (this._selectedID != theater.id ) )
	{
		var nowShowingList = theater.now_showing;
		var movieID;
		var movie;
		
		// empty the _movies object and key array
		BoxOffice.Theater._movies = {};
		BoxOffice.Theater._movieKeys = [];
		
		// get the movies from the BoxOffice.Theater list so the the times are for the
		// correct theater
		for ( var index in nowShowingList )
		{
			movie = nowShowingList[index];
			movieID = movie.tms_id;
			
			if ( movieID )
			{
				BoxOffice.Theater._movies[movieID] = movie;
				BoxOffice.Theater._movieKeys.push(movieID);
			}
		}
		this._selectedID = theater.id;
	}
	return BoxOffice.Theater._movies;
}

//---------------------------------------------------------------------------------------
function TheaterNameComparator(a, b)
{ 
	var A = a.name.toLowerCase();
	var B = b.name.toLowerCase();

	if (A < B) {
		return (-1);
	} else if (A > B) {
		return  (1);
	}

	return (0);
}

//---------------------------------------------------------------------------------------
BoxOffice.Theater.shouldFetchNewTheaterData = function() {

	if (!this._lastQueryDate) {
		return (true);
	}
	// getDate() returns day of month as number
	var midnightHasPassedSinceLastFetch = (new Date().getDate() != this._lastQueryDate.getDate());
	
	return (midnightHasPassedSinceLastFetch);
}

//---------------------------------------------------------------------------------------
function theaterDataFetched(evt, req) {

	var doc;

	try {
			doc = req.responseText;
			if (!doc)
			{
				handleNetworkError();
				return;
			}
			
			// reset key array
			BoxOffice.Theater._key.length = 0;
			BoxOffice.Theater._obj = {};
				
			//	call Safari's built-in JSON parser
			var theaters = (new Function("return " + doc))();
			
			BoxOffice.Theater._lastQueryDate = new Date();
	
			theaters = theaters[0].pages[0];
			theaters.sort(TheaterNameComparator);
	
			for (var i = 0;i < theaters.length;i++)
			{
				var	theaterID = theaters[i].id;
				
				BoxOffice.Theater._obj[theaterID] = theaters[i];
				BoxOffice.Theater._key.push(theaterID)
			}

			if (!gCurrTheaterID) {
				gCurrTheaterID = theaters[0].id;
		}

	} catch (e) {
		alert("Runtime Error: " + e);
		// handle missing network connection or no vendor data
		BoxOffice.handleNoDataAvailable();
	} finally {
		req = doc = null;
		startPosterRollLoop();
	}
}

//---------------------------------------------------------------------------------------
BoxOffice.Theater.fetchTheaterData = function() {

	if (this._req) {
		this._req.abort();
		this._req = null;
	}
	BoxOffice.Theater._infoReq = null;

	//	http://trailers.apple.com/trailers/global/scripts/showtimes.theaters.php?
	//	show_date=2011-6-20&items_per_page=5&postal_code=95124
	var url = "http://trailers.apple.com/trailers/global/scripts/showtimes.theaters.php?show_date="
		+ getDate() + "&items_per_page=20";

	if ( gCurrPostalCode )
		url += "&postal_code=" + gCurrPostalCode;

	var req = BoxOffice.prepareAsyncGetRequest(url, theaterDataFetched);

	this._req = req;
	this._req.send(null);
}

//---------------------------------------------------------------------------------------
// #mark private
//---------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------
var showingErrorMsgBox;
function showErrorMsgBox() {

	var errorMsgBox = Util.$("errorMsgBox");

	errorMsgBox.innerHTML = getLocalizedString("No movie data available");

	Util.hideElement(Util.$("posterRollRgn"));
	Util.showElement(errorMsgBox);
	
	askBoxOfficeForUpdate();
	showingErrorMsgBox = false;
}

//---------------------------------------------------------------------------------------
function getTextContentOfFirstDescendantByTagName(parent, tagName) {
	var nodeList = parent.getElementsByTagName(tagName);
	if (nodeList && nodeList.length) {
		return nodeList.item(0).textContent;
	} else {
		return "";
	}
}


/*
function theaterObjectForTheaterElement(theaterEl) {
	var id = theaterEl.getAttribute("id");
	var tmsid = theaterEl.getAttribute("tmsid");
	var isWiredAttr = theaterEl.getAttribute("iswired");
	var canBuyTickets = (isWiredAttr && "true" == isWiredAttr.toLowerCase());
	var nameEls = theaterEl.getElementsByTagName("name");
	var name = "";
	if (nameEls && nameEls.length) {
		name = stringByRemovingDashes(nameEls.item(0).textContent);
	}
	var theater = new Theater(id, name, canBuyTickets);
	theater.tmsid 	 = tmsid;
	theater.address  = addressObjectForTheaterElement(theaterEl);
//	theater.features = featuresArrayForTheaterElement(theaterEl);
	theater.mapUrl   = mapUrlStringForAddressObject(theater.address);
		
	return theater;
}

function addressObjectForTheaterElement(theaterEl) {
	var address = {};
	address.street 	= getTextContentOfFirstDescendantByTagName(theaterEl, "address1");
	address.city 	= getTextContentOfFirstDescendantByTagName(theaterEl, "city");
	address.state	= getTextContentOfFirstDescendantByTagName(theaterEl, "state");
	address.zip 	= getTextContentOfFirstDescendantByTagName(theaterEl, "postalcode");
	address.country = getTextContentOfFirstDescendantByTagName(theaterEl, "country");
	address.phone = getTextContentOfFirstDescendantByTagName(theaterEl, "phonenumber");
	return address;
}

function mapUrlStringForAddressObject(address) {
	return encodeURI("http://maps.google.com/maps?&q=" 
		+ address.street + ",+"
		+ address.city 	 + ",+"
		+ address.state  + ",+" 
		+ address.zip);
}

function consumePerformanceDataForTheater(theater, theaterEl) {
	var theaterId = theater.id;
	var movieEls = theaterEl.getElementsByTagName("movie");
	var movieEl;
	var movieId;
	var movie;
	for (var i = 0; i < movieEls.length; i++) {
		movieEl = movieEls[i];
		movieId = movieEl.getAttribute("id");
		movie = allMoviesTable[movieId];
		theater.movies.push(movie);
		var performanceEls = movieEl.getElementsByTagName("performance");
		var prformanceEl;
		var showdate;
		var showtime;
		var times = [];
		for (var j = 0; j < performanceEls.length; j++) {
			performanceEl = performanceEls[j];
			showdate = performanceEl.getAttribute("showdate");
			showtime = performanceEl.getAttribute("showtime").replace(" PM", "pm").replace(" AM", "am");
			times.push(new Time(showdate, showtime));
		}
		if (movie) {
			if (!containsObject(movie.theaters, theater)) {
				movie.theaters.push(theater);
				movie.times[theaterId] = times;
			}
		}
	}
}

movieObjectForMovieElement.anTheRegex = /^(the|an)\s+(.+)/im;
movieObjectForMovieElement.underscoreRegex = /_/g;


function movieObjectForMovieElement(movieEl) {
	var id = movieEl.getAttribute("id");
	var title 		  = getTextContentOfFirstDescendantByTagName(movieEl, "title");
	title = title.replace(movieObjectForMovieElement.anTheRegex, "$2, $1");
	movie = new Movie(id, title);
	movie.rating 	  = getTextContentOfFirstDescendantByTagName(movieEl, "rating");
	movie.releaseDate = getTextContentOfFirstDescendantByTagName(movieEl, "releasedate");
	movie.synopsis 	  = getTextContentOfFirstDescendantByTagName(movieEl, "synopsis");
	var genreText 	  = getTextContentOfFirstDescendantByTagName(movieEl, "genre");
	var genreArray = [];
	if (genreText) {
		genreText = genreText.replace(movieObjectForMovieElement.underscoreRegex, " ");
		if (genreText.indexOf(",") > -1) {
			genreArray = genreText.split(",");
		} else {
			genreArray = [genreText];
		}
	}
	movie.genres = genreArray;
	movie.cast = [];
	var actorEls = movieEl.getElementsByTagName("member");
	if (actorEls) {
		for (var i = 0; i < actorEls.length; i++) {
			movie.cast.push(actorEls[i].textContent);
		}
	}
	movie.complete = false;	
	return movie;
}

//	Theater class
function Theater(id, name, canBuyTickets, movies) {
	this.id = id;
	this.name = name;
	this.canBuyTickets = canBuyTickets;
	this.movies = [];
}

Theater.prototype.compareTo = function (that) {
	if (this.name < that.name)
		return -1;
	else if (that.name < this.name)
		return 1;
	else 
		return 0;
};

//	Time class
function Time(dateStr, timeStr) {
	this.date = dateStr;
	this.time = timeStr;
}

//	Movie class
function Movie(id, title) {
	this.id = id;
	this.title = title;
	this.sortTitle = title.toLowerCase();
	this.times = {};
	this.theaters = [];
	this.trailer = {};
	this.posterUrl = MOV_POSTER_DEFAULT;
	this.trailer = { url:"#", height:-1 };
}

Movie.prototype.compareTo = function (that) {
	if (this.sortTitle < that.sortTitle)
		return -1;
	else if (that.sortTitle < this.sortTitle)
		return 1;
	else 
		return 0;
};
*/
